/* (C) 2021 YiRing, Inc. */
package com.yiring.app.vo;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AccessLevel;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import lombok.experimental.FieldDefaults;

import java.io.Serializable;
import java.util.List;

/**
 * 分页查询响应公共类
 *
 * @author ifzm
 * @version 0.1 2019/3/10 16:29
 */
@ApiModel("分页查询响应公共类")
@NoArgsConstructor
@Getter
@Setter(value = AccessLevel.PRIVATE)
@FieldDefaults(level = AccessLevel.PRIVATE)
public class PageVo<T extends Serializable> implements Serializable {

    private static final long serialVersionUID = 6103761701912769946L;

    @ApiModelProperty(value = "数据")
    List<T> data;

    @ApiModelProperty(value = "数据总数", example = "100")
    Long total;

    /**
     * 构建一个 PageVo
     * @param data 数据
     * @param total 总数据量
     * @return PageVo
     */
    @SuppressWarnings({ "unused" })
    public static <R extends Serializable> PageVo<R> build(List<R> data, long total) {
        PageVo<R> vo = new PageVo<>();
        vo.setData(data);
        vo.setTotal(total);
        return vo;
    }
}
